
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>PHP搭建简单暴力的mvc / 憋错料</title>

    <meta name="description" content="PHP搭建简单暴力的mvc 对于一个web系统来说,我们使用mvc很必要, 给我们带来的是清晰的结构,易运维,易扩展, mvc 我对其的理解应该叫mxvc, 多了一个x , 这个x代表什么,x可以理解为 relay,proxy,adapter 亦可, 先来看下面这张图 这是我们系统的mxvc结构图, 大概分成四个部分, 第一部分 php-libs 这是提供mvc框架的底层库,这块需要注意的是这是一个和业务无关的代码模块,里面还有数据库封装类等, 我把数据库也画在 这个图中了,可以看出数据库的重要性,其实所有的web系统都是">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">PHP搭建简单暴力的mvc</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>对于一个web系统来说，我们使用mvc很必要， 给我们带来的是清晰的结构，易运维，易扩展，</p>
<p>mvc 我对其的理解应该叫mxvc， 多了一个x ， 这个x代表什么，x可以理解为 relay，proxy，adapter 亦可，</p>
<p>先来看下面这张图</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMC5jbmJsb2dzLmNvbS9ibG9nMjAxNS83NTU1OTgvMjAxNTA1LzE2MTQ1MTQ2MjgyOTUwMi5qcGc=.jpg" /></p>
<p>这是我们系统的mxvc结构图， 大概分成四个部分，</p>
<p>第一部分 php-libs</p>
<p>这是提供mvc框架的底层库，这块需要注意的是这是一个和业务无关的代码模块，里面还有数据库封装类等， 我把数据库也画在</p>
<p>这个图中了，可以看出数据库的重要性，其实所有的web系统都是围绕着数据库增删改查上面的封装</p>
<p>把数据库画出来还有个重要的目地是告诉大家对数据的操作要入口唯一， 在我系统里面只有DAO</p>
<p>下面封装的类可以访问到数据库，入口的唯一虽然有短处，但是利大于弊，切记</p>
<p>第二部分 controller</p>
<p>我们先来说控制层，最后再说mx，</p>
<p>从系统结构上来说controller是接入层，这里面的类是相互独立的，也就是说我们在controller类里面写的方法，理论上只能被类自己的其他方法使用，所以写的每个方法都要考虑好，是不是应该放在这里面还是放在mx里面，我们要衡量好，同样功能的方法最好不要出现第二次，这里面的代码要很简洁，最好不要有太多的业务逻辑的处理，全部交给后端的逻辑层去处理，</p>
<p>第三部分 view</p>
<p>这里面也就是前端，静态文件css js pic 还有template 记住这里面的静态文件是不走后端业务逻辑的，用户可以直接访问的，所以要设计好你的文件夹结构， 哪些可以暴露，哪些不可以暴露</p>
<p>第四部分 mx 即model +x （ proxy/adapter/relay )</p>
<p>毋庸置疑这是你系统最重要的部分，心脏，</p>
<p>简单说一下我们的设计， 这里面有两个公用的文件夹，Service和Utils 他们分别放公共的服务类和工具类，</p>
<p>比如你的异常封装类和错误码都可以放在Service里面，utils下面比如你的getClientIp这样的方法可以放在这个下面</p>
<p>这里面的DAO可以看到所有数据库的封装类在这个下面都可以找到，而且出处唯一，只有这里面可以找到，基本上一个表对应一个类即一个文件， 这里面的文件比较简单就是数据库的增删改查，保证如果外面想对这个表操作只有通过这个类才可以实现</p>
<p>下面就是X 因为我们一个前端的请求可能需要多个表的结果，或者一个封装好的数据接口可以提供给上游好几个controller共用，</p>
<p>这个时候X的价值就体现出来了， 保证代码的简洁，提高代码的复用全靠这个层的代码了，更多的细节可以自己慢慢总结，</p>
<p>只要我们有清晰的逻辑设计，职责清晰，分工明确的代码，兵来将挡水来土掩，即使有大的改动也不怕</p>
<p>链接提供上面架构的php-libs ： https://github.com/Allenhaozi/crab&nbsp; 供参考</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-06 21:13:27 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>PHP搭建简单暴力的mvc的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyKoLL3.html" rel="bookmark">【Spring】搭建最简单的Spring MVC项目</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				每次需要Spring MVC的web项目测试一些东西时,都苦于手头上没有最简单的Spring MVC的web项目,现写一个. &gt; 版本说明 首先要引入一些包,Spring的IOC.MVC包就不用说了.还有Jackson的包,因为默认情况下Controller的方法如要返回Json,用的是此框架. &lt;dependencies&gt; &lt;dependency&gt; &lt;groupId&gt;javax.servlet&lt;/groupId&gt; &lt;artifactId&gt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wjNbb0.html" rel="bookmark">&lbrack;angularjs&rsqb; MVC &plus; Web API &plus; AngularJs 搭建简单的 CURD 框架</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				MVC + Web API + AngularJs 搭建简单的 CURD 框架 GitHub 地址:https://github.com/liqingwen2015/Wen.MvcSinglePage 布局页的引用 &lt;script src=&quot;~/Scripts/jquery-1.10.2.min.js&quot;&gt;&lt;/script&gt; &lt;script src=&quot;~/Scripts/bootstrap.min.js&quot;&gt;&lt;/script&g			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0e765p4.html" rel="bookmark">maven&sol;eclipse搭建ssm&lpar;spring&plus;spring mvc&plus;mybatis&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				maven/eclipse搭建ssm(spring+spring mvc+mybatis) 前言 本文旨在利用maven搭建ssm环境,而关于maven的具体内容,大家可以去阅读&lt;Maven 实战&gt;.其实园内这方面文章已有不少,那么为什么我还要重复造轮子呢?我只是想记录自己的实践过程罢了,附带着给别人以参考.对于别人的博文,看了固然好,要是能付之实践,那就更好了! maven安装 安装过程挺简单的,去apache下载apache-maven的zip包,解压到一个目录下,如下图 接下来配置win			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0nbkPK0.html" rel="bookmark">SpringMVC笔记&mdash;&mdash;SSM框架搭建简单实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				落叶枫桥 博客园 首页 新随笔 联系 订阅 管理 SpringMVC笔记——SSM框架搭建简单实例 简介 Spring+SpringMVC+MyBatis框架(SSM)是比较热门的中小型企业级项目开发的框架,对于新手来说也是比较容易学习入门的.虽说容易,但在框架搭建过程中仍然遇到了许多问题,因此用实例记录下来吧. 实例 第一步——导包 Spring框架包及其依赖包 MyBatis框架包及其依赖包 MyBatis-EhCache架包 C3P0架包 MySql数据库驱动包 项目架包如下: 项目结构如			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MXbp6w3.html" rel="bookmark">spring&plus;shiro搭建简单安全框架</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.简介:shiro是一个安全框架,顾名思义就是对系统的访问进行安全控制,包含用户身份认证(登录),用户权限控制(通过角色,权限字符串等). 权限里面很关键的两个东西:认证和授权. 1. 认证没什么好说的,目的就是判断用户的账号密码是否正确之类的,授权的作用嘛,简单的解释就是给用户赋予相应的权限. 2. 判断一个用户有没有权限访问,无非是拦截URL能否访问,分为以下几个操作 ①判断当前URL是否需要拦截,不需要则放行,需要则进入下一步②判断用户是否已登陆,有则下一步,无则抛出401未认证④从资源			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vE5ba0.html" rel="bookmark">拿nodejs快速搭建简单Oauth认证和restful API server攻略</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				拿nodejs快速搭建简单Oauth认证和restful API server攻略:http://blog.csdn.net/zhaoweitco/article/details/21708955 最近一直在鼓捣这个东西,拿出来分享下一下经验吧,其实很简单,一点也不难. 首先需求是这样,给自己的网站要增加API服务,API分为两种,公共的和私有授权的,授权的使用Oauth方法认证身份,API格式均为JOSN和JSONP. 嗯,别的语言我也没怎么学过,首先是找合适的框架进行实现吧.本身网站使用的e			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPNv6P3.html" rel="bookmark">KVC&sol;KVO之暴力的KVC</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本章将分为两个部分: KVC之Set/Get KVC之键值路径 KVC之Set/Get 类A中有3个变量,都是private权限,关于访问权限的,请参见&lt;Objective-C 成员变量&gt; A.h @interface A : NSObject { @private NSString *str; NSInteger value; //注意这里没星号哦哦哦 NSArray *array; } @end A.m:重写Description函数,用于NSLog @implementation A /			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xQmbQ3.html" rel="bookmark">玩转Node&period;js（四）-搭建简单的聊天室</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				玩转Node.js(四)-搭建简单的聊天室 Nodejs好久没有跟进了,最近想用它搞一个聊天室,然后便偶遇了socket.io这个东东,说是可以用它来简单的实现实时双向的基于事件的通讯机制.我便看了一些个教程使用它来搭建一个超级简单的聊天室. 初始化项目 在电脑里新建一个文件夹,叫做“chatroom”,然后使用npm进行初始化: $ npm init 然后根据提示以及相关信息一步一步输入,当然也可以一路回车下去,之后会在项目里生成一个package.json文件,里面的信息如下: 1 $ ca			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3r5YmX0.html" rel="bookmark">使用java搭建简单的ligerui环境</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近因为工作需要,学习了ligerui框架.但是,因为在公司,我们只是作为最低层的码农,所以环境都已经搭建好了,我们这些码农平时都是直接拿到工程,然后在别人的框架上不断的ctrl + c.ctrl + v,然后修修补补.所以为了摆脱这种困境,决定自己使用简单的servlet搭建一个ligerui,然后测试下ligerui这玩意到底是怎么跑起来的. 1.下载ligerui相关组件.这个很简单,直接去www.ligerui.com即可找到. 2.使用Eclipse创建一个web工程,然后搭建下面这个			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NJXpw4.html" rel="bookmark" class="title">&amp;&num;181&semi;Vision中的Key Sequence 中文</a>
					<div>
						注:这里的Key Sequence 译作&quot;键序列&quot;,可能有些欠妥. 使用键序列来传递μVision参数给外部程序.键序列是键代码和文件代码的组合.键序列用于如Tools,SVCS, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBAdyK4.html" rel="bookmark" class="title">Hadoop中文编码乱码相关问题</a>
					<div>
						mapreduce程序处理GBK编码数据并输出GBK编码数据, hadoop涉及输出文本的默认输出编码统一用没有BOM的UTF-8的形式,但是对于中文的输出window系统默认的是GBK,有些格式文件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgXqRN0.html" rel="bookmark" class="title">Qt&colon; 自动调整到最合适的大小（不是很明白）</a>
					<div>
						SortDialog::SortDialog(QWidget *parent) : QDialog(parent) { setupUi(this); groupBox_2-&gt;hide(); gr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dx8dw0.html" rel="bookmark" class="title">JSP中EL表达式取值问题记录（未解决）</a>
					<div>
						***************************2015-10-28 22:21************************* 问题描述如下: 在当前的jsp页面已经有了如下代码: &lt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyKDYA3.html" rel="bookmark" class="title">MySQL server has gone away 问题的解决方法</a>
					<div>
						多种原因: http://www.jb51.net/article/23781.htm 最常见是数据过大, 注意优化sql语句,避免过大 另外更改可接受缓存量  在my.cnf文件中添加或者修改以下变 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDoke94.html" rel="bookmark" class="title">mac os x 设置终端快捷键</a>
					<div>
						大家都知道在linux下可以用ctr+alt+t组合快捷来打开终端,那么在OS X上可以吗?答案是肯定的,其实OS X上很多功能都可以通过Apple自家的Automator.app创建,且使用此方法可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0n5gDpM.html" rel="bookmark" class="title">对象和类，日历</a>
					<div>
						package com.xiaolu;import java.text.DateFormatSymbols;import java.util.*;/** * @version 1.4 2007-04- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02LAA24.html" rel="bookmark" class="title">【IHttpHandler】IHttpModule实现URL重写</a>
					<div>
						1.用自定义IHttpModule实现URL重写 一般来说,要显示一些动态数据总是采用带参数的方式,比如制作一个UserInfo.aspx的动态页面用于显示系统的UserInfo这个用户信息表的数据, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXLqZGM.html" rel="bookmark" class="title">一个随机数发生器（一）</a>
					<div>
						老黄.老银和老阳共事宇宙中心某互联网企业H,并且同在一个由校招新生组成的Team里.刚走出校园的他们,对自己去年在校招这场演技大比拼中的表现意犹未尽,因此常会拿一些没什么实际意义的技术问题大谈特谈.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBanRA4.html" rel="bookmark" class="title">WHY数学表达式的3D可视化</a>
					<div>
						WHY数学表达式的3D可视化 很早之前我就有这种想法,将数学表达式的图形显示出来.最近终于实现了这套较为完善的版本,将其代码公布,也为开源做点贡献.首先系统中定义一套脚本语言格式,用于描述数学表达式. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YRRqq3.html" rel="bookmark" class="title">Docker 安装jupyter</a>
					<div>
						1. 利用image(name是tingting) sudo docker run -it --net=host tingting --net=host:让container可以上网,安装原来的sud ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXnbkq3.html" rel="bookmark" class="title">yii2  php  namespace 引入第三方非namespace库文件时候，报错：Class not found  的解决</a>
					<div>
						一个类文件时namespace的库方式 通过下面的方式引入类,报错  Class Not Found: namespace frontend\block\customer\account; use Y ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/382VRRM.html" rel="bookmark" class="title">&lbrack;CSharp&rsqb;1 占位符、转义字符</a>
					<div>
						C# Placeholder There are 2 ways to output multiple characters in C#. One: static void Main() {       ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MD8gNpM.html" rel="bookmark" class="title">10 Myths About Introverts</a>
					<div>
						By Carl King [ Translations: Spanish| German | Dutch | Italian | Portuguese ] I wrote this list in l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmNKD10.html" rel="bookmark" class="title">《Mycat学习笔记》 第四篇&period; MyCat 日志简单分析</a>
					<div>
						环境说明 Windows 7  Mycat 1.5 Mysql 5.5 一个实例两个库 traveldata_db_1 和 traveldata_db_2 mysql&gt; show databas ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jL6dW4.html" rel="bookmark" class="title">&lbrack;转&rsqb;Objective-C Runtime 运行时之六：拾遗</a>
					<div>
						前面几篇基本介绍了runtime中的大部分功能,包括对类与对象.成员变量与属性.方法与消息.分类与协议的处理.runtime大部分的功能都是围绕这几点来实现的. 本章的内容并不算重点,主要针对前文中对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVmDQQ4.html" rel="bookmark" class="title">已知二叉树的先序遍历和中序遍历序列，输出后序遍历序列</a>
					<div>
						参考:http://blog.csdn.net/u010607031/article/details/37578957 //#include&lt;stdio.h&gt;#include&lt;str ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RxbOq4.html" rel="bookmark" class="title">windows下VirtualBox的Linux获取主机串口（USB转串口）</a>
					<div>
						1.插上usb转串口线(在virtualbox的设置面板的usb选项中加对应的USB转串口的选项,但是这个驱动是我们WIN7里面的) 2.(在Ubuntu窗口上方的&quot;设备&quot;--&g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02gpRn3.html" rel="bookmark" class="title">IPublishedContent 查询  父母 子节点内容</a>
					<div>
						Collections .Children 子节点 1 &lt;ul&gt; 2 @foreach(var item in Model.Content.Children) 3 { 4 &lt;li&g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVKOek0.html" rel="bookmark" class="title">MyBean-关于plugMap共享对象</a>
					<div>
						plugMap实现了对象的存储,使用setObject,和getObject来对对象进行存储   内部其实是一个列表,而且他会在释放的时候会情况尝试释放所有的对象,所以如果你共享的对象提前进行了释放, ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
